/* This file is automatically copied form (NexJ PhoneGap) DevicePlugin project.
 * Do not modify this file -- YOUR CHANGES WILL BE ERASED! 
 */ 
package com.nexj.bluetooth;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.json.JSONObject;

import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.Intent;

public class BluetoothAndroid
{
    protected static BluetoothAdapter BLUETOOTH_ADAPTER;
    protected final String m_sLogTag = "BluetoothAndroid";

    static
    {
        // Android 2.3 device did not allow lazy initialization of this value
        BLUETOOTH_ADAPTER = BluetoothAdapter.getDefaultAdapter();
    }

    public static BluetoothAdapter getAdapter()
    {
        return BLUETOOTH_ADAPTER;
    }

    public static boolean isSupported()
    {
        return getAdapter() == null ? false : true;
    }

    public static boolean isEnabled()
    {
        if (isSupported())
        {
            return getAdapter().getState() == BluetoothAdapter.STATE_ON;
        }

        return false;
    }

    public static boolean isDisabled()
    {
        if (isSupported())
        {
            return getAdapter().getState() == BluetoothAdapter.STATE_TURNING_OFF || getAdapter().getState() == BluetoothAdapter.STATE_OFF;
        }

        return false;
    }

    public static void enable(Activity activity)
    {
        if (isSupported())
        {
            activity.startActivity(new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE));

            // This circumvents user interaction to enable Bluetooth
            // getAdapter().enable();
        }
    }

    public static void disable()
    {
        if (isSupported())
        {
            getAdapter().disable();
        }
    }

    public static void enableDiscovery(Activity activity, int duration)
    {
        if (isSupported())
        {
            Intent intent = new Intent(BluetoothAdapter.ACTION_REQUEST_DISCOVERABLE);
            intent.putExtra(BluetoothAdapter.EXTRA_DISCOVERABLE_DURATION, duration);
            activity.startActivity(intent);
        }
    }

    public static void disableDiscoverable()
    {
        if (isSupported())
        {
            getAdapter().cancelDiscovery();
        }
    }

    public static boolean isDiscoverable()
    {
        if (isSupported())
        {
            return getAdapter().getScanMode() == BluetoothAdapter.SCAN_MODE_CONNECTABLE_DISCOVERABLE;
        }

        return false;
    }

    public static List<Object> getBondedDevices() throws Exception
    {
        ArrayList<Object> bondedDevices = new ArrayList<Object>(8);

        if (isSupported())
        {
            Iterator<BluetoothDevice> itr = getAdapter().getBondedDevices().iterator();

            while (itr.hasNext())
            {
                BluetoothDevice bluetoothDevice = itr.next();
                JSONObject deviceInfo = new JSONObject();

                deviceInfo.put("name", bluetoothDevice.getName());
                deviceInfo.put("address", bluetoothDevice.getAddress());
                deviceInfo.put("isBonded", true);

                bondedDevices.add(deviceInfo);
            }
        }

        return bondedDevices;
    }
}
